--- net/socket/ssl_client_socket_nss.cc
+++ net/socket/ssl_client_socket_nss.cc
@@ -300,12 +300,17 @@ int SSLClientSocketNSS::InitializeSSLOptions() {
 
   // Tell NSS who we're connected to
   PRNetAddr peername;
-  socklen_t len = sizeof(PRNetAddr);
-  int err = transport_->GetPeerName((struct sockaddr *)&peername, &len);
+  sockaddr socker;
+  socklen_t len = sizeof(sockaddr);
+  int err = transport_->GetPeerName(&socker, &len);
   if (err) {
     DLOG(ERROR) << "GetPeerName failed";
     return 9999;  // TODO(port): real error
   }
+  sockaddr_in* sockaccess = (struct sockaddr_in *) &socker;
+  peername.inet.family = sockaccess->sin_family;
+  peername.inet.ip     = sockaccess->sin_addr.s_addr;
+  peername.inet.port   = sockaccess->sin_port;
   memio_SetPeerName(nss_fd_, &peername);
 
   // Grab pointer to buffers
diff --git net/socket/ssl_test_util.cc net/socket/ssl_test_util.cc
index a58863e..29b49ff 100644
